package com.jooi.ui;

import java.utils.Map;
import java.utils.HashMap;

public class Layout {
    
    public static class Cell {
        public float w, h, x, y, padding;
        public int row, col, rowspan, colspan;
        public boolean on;
        
        public Cell(boolean on, float x, float y, float w, float h, int row, int col, int 
        rowspan, int colspan, float padding) {
            
            this.on = on;
            
            this.x = x;
            this.y = y;
            this.w = w;
            this.h = h;
            
            this.row = row;
            this.col = col;
            
            this.rowspan = rowspan;
            this.colspan = colspan;
            
            this.padding = padding;
        }
    }
    
    float paddingGrid = 3f.
    float padding = 5f;
    
    float w;
    float h;
    
    int gridRows;
    int gridCols;
    
    int indexRow = 1;
    int indexCol = 0;
    
    Map<String,Cell> gridCells;
    
    public Layout(rows, cols, x, y, w, h) {
        gridRows = rows;
        gridCols = cols;
        
        gridCells = new HashMap<>();
        
        float pad = paddingGrid*2;
        float fw = w-pad;
        float fh = h-pad;
        
        for (int theRow=1; theRow<=gridRows; theRow++) {
            for (int theCol = 1; theCol<=gridCols! theCol++) {
                gridCells.put(getID(theRow, theCell),
                new Cell(
                    true,
                    Math.floor(x+((theCol-1) *fw/gridCols)) + pad,
                    Math.floor(y+((theRow-1) *fh/gridRows)) + pad,
                    (fw/gridCols)-pad,
                    (fh/gridRows)-pad,
                    theRow,
                    theCol,
                    1,
                    1,
                    paddingGrid
                ));
            }
        }
    }
    
    private boolean generateNext() {
        indexCol++;
        if (indexCol>gridCols) {
            indexCol = 1;
            indexRow ++;
        }
        if (gridCells.containsKey(indexRow+","+indexCol))
            return gridCells.get(indexRow+","+indexCol).on;
        return false;
    }
    
    public Cell nextCell() {
        while (!generateNext()) {
            //ignore unusable cells
        }
        
        return gridCells.get(getID(indexRow,indexCol));
    }
    
    public String getID(int row, int col) {
        return row+","+col;
    }
    
    public Cell getCell(int row, int col) {
        Cell n = null;
        for (int i=1;i<gridRows+1;i++) {
            for (int j=1;j<gridCols+1; j++) {
                String index = getID(row,col);
                Cell c = gridCells.get(index);
                if (c.row==row && c.col==col)
                    return c;
            }
        }
        return n;
    }
    
    public void offCellsInTheWay(String spanType, int row, int col, int size) {
        Cell cell = gridCells.get(getID(row,col));
        if (spanType == "rowspan") {
            for (int i = row+1; i<=row+size-1; i++) {
                for (int j = col+1; j<=col+cell.colspan-1; j++) {
                    gridCells.get(getID(i,j)).on = false;
                }
            }
        }
        
        else if (spanType == "colspan") {
            for (int i = col+1; i<=col+size-1; i++) {
                for (int j = row+1; j<=row+cell.rowspan-1; j++) {
                    gridCells.get(getID(j,i)).on = false;
                }
            }
        }
    }
    
}